{% extends "base.html" %}
{% load transitions %}

{% block content %}
<h3>Ma note de frais</h3>

<form action="." method="POST">
<section style="text-align: right;">
  {% with available_transitions=object|get_available_transitions:request.user %}
    {% csrf_token %}
    <div>
    {% for transition in available_transitions %}
    <button type="submit" name="{{ transition }}">{{ transition | get_transition_display }}</button>
    {% endfor %}
    </div>
    <div style="display: inline-block;">
    <br />
    {% if "approve" in available_transitions and perms.expense_report.manage_expense_report %}
    <input type="text" name="document_id" id="id_document_id" placeholder="Si OK : ID NDF2042-000" value="{{ next_document_id }}" />
    {% endif %}
    {% if "reject" in available_transitions and perms.expense_report.manage_expense_report %}
    <textarea name="reason" cols="21" rows="3" id="id_reason" placeholder="Si rejetée : raison du rejet"></textarea>
    {% endif %}
    </div>
    {% if "submit" in available_transitions %}
    <blockquote class="info">
      En soumettant cette note de frais, le membre certifie que tous les
      éléments constituant ce document sont exacts.
    </blockquote>
    {% endif %}

  {% if object.state == "draft" and object.reason != "" %}
  <blockquote class="warn">
    La note de frais a été rejetée. Raison : {{ object.reason }}
  </blockquote>
  {% endif %}

  {% if "submit" in available_transitions or perms.expense_report.manage_expense_report %}
  {% if object.state != "_closed" %}
  <br />
  <a href="{% url "expense-report-update" object.pk %}"><button type="button">Éditer</button></a>
  {% endif %}
  {% endif %}
  {% endwith %}
</section>

<section>
  <table style="text-align: revert;">
    <legend>Informations</legend>
    <thead>
      <th>ID</th>
      <th>Status</th>
      <th>{% if object.submitted_at %}Soumis à{% else %}Créée à{% endif %}</th>
      <th>Créé par</th>
      <th>Événement</th>
      <th>Descriptif</th>
      <th>Approuvé par</th>
      <th>Montant</th>
      <th>Document</th>
    </thead>
    <tr>
      <td>{% if object.document_id %}{{ object.document_id }}{% endif %}</td>
      <td>{{ object.get_state_display }}</td>
      <td>{% if object.submitted_at %}{{ object.submitted_at.date }}{% else %}{{ object.created.date }}{% endif %}</td>
      <td><a href="{% url "user-banking-information-detail" object.created_by.banking_information.pk %}">{{ object.created_by }}</a></td>
      <td class="text-wrap">{{ object.get_event_display }} : {{ object.event_description }}</td>
      <td class="text-wrap">{{ object.description }}</td>
      <td>{{ object.get_approved_by_display }}</td>
      <td>{{ object.amount }} €</td>
      <td>
        {% if object.document %}
          <a href="{{ object.document.url }}" target="_blank">Télécharger</a>
        {% endif %}
        {% if object.state != "draft" and object.state != "submitted" %}
          <button type="submit" name="generate">Générer</button>
        {% endif %}
      </td>
    </tr>
  </table>
</section>

<section>
  <legend>Détail des achats</legend>
  <table style="text-align: revert;">
    <thead>
      <th>Date</th>
      <th>Type</th>
      <th>Descriptif</th>
      <th>Montant</th>
      <th>Justificatif</th>
      {% if object.state != "draft" and object.state != "submitted" %}
      <th>Compte destination</th>
      <th>Compte source</th>
      {% endif %}
    </thead>
    <tbody>
      {% for entry in object.entries.all %}
      <tr>
        <td>{{ entry.date }}</td>
        <td>{{ entry.get_expense_type_display }}</td>
        <td class="text-wrap">{{ entry.description }}</td>
        <td>{{ entry.amount }} €</td>
        <td><a href="{{ entry.proof.url }}" target="_blank">Télécharger</a></td>
        {% if object.state != "draft" and object.state != "submitted" %}
        <td>{{ entry.account_dest }}</td>
        <td>{{ entry.account_source }}</td>
        {% endif %}
      </tr>
      {% endfor %}
    </tbody>
  </table>
</section>

{% if object.state != "draft" and object.state != "submitted" and object.state != "rejected" %}
<section>
  <legend>Entrées comptables</legend>
  {% if not object.accounting_entries %}
  <p>
  Les comptes sources et destination n'ont pas tous été spécifiés pour cette
  note de frais. Veuillez tous les renseigner pour avoir accès aux entrées
  comptables générées.
  </p>
  {% else %}
  <pre><code>
  {{ object.accounting_entries }}
  </code></pre>
  {% endif %}
</section>
{% endif %}

<section>
  <legend>Métadonnées</legend>
  <table style="text-align: revert;">
    <thead>
      <th style="text-align: right;">Crée à</th>
      <th>Crée par</th>
      <th>Dernière modification à</th>
      <th>Dernière modification par</th>
    </thead>
    <tbody>
      <tr>
        <td style="text-align: right;">{{ object.created }}</td>
        <td>{{ object.created_by }}</td>
        <td>{{ object.modified }}</td>
        <td>{{ object.modified_by }}</td>
      </tr>
    </tbody>
  </table>
</section>

{% include "log_entries.html" %}
</form>
{% endblock %}
